import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

/*

Modification History
--------------------

Version 1.0
	This example shows how the elements of XML data are read into a program

*/

public class MyXMLHandler extends DefaultHandler {


	    static public void main(String[] args) throws Exception {

        System.out.println("\nVersion 1.0 of MyXMLHandler in example01\n");

		/*Create a SAX Parser Factory*/
        SAXParserFactory parseFactory = SAXParserFactory.newInstance();

		/*Obtain a SAX Parser */
        SAXParser saxParser = parseFactory.newSAXParser();

		/*XML Reader is the interface for reading an XML document using callbacks*/
        XMLReader xmlReader = saxParser.getXMLReader();

		/*Attach ContentHandler - the callbacks like startDocument,startElement etc. are o
		  overridden by the setContentHandler to trap them into user code*/
        xmlReader.setContentHandler(new MyXMLHandler());

		/*Parse an XML document - the document is read and overriden callbacks in the MyXMLHandler are invoked*/
        xmlReader.parse("CarParts.xml");

    } //End of main


    public void startDocument()
	    {
	        System.out.println("\n Start Document: -----Reading CarParts.xml with MyXMLHandler------\n");
	    }

	    public void startElement(String namespaceURI, String localName,
	                             String qualifiedName, Attributes elementAttributes)
	    {
	        System.out.println("Start Element-> "+qualifiedName);
	    }

	    public void endElement(String namespaceURI, String localName,
	                             String qualifiedName)
	    {
	        System.out.println("End Element-> "+qualifiedName);
	    }

	    public void endDocument()
	    {
	        System.out.println("\n End Document: ----------------Finished Reading the document---------------------\n");
    }
}
