
/*

Modification History
--------------------

Version 1.0
	This example shows how an XML file is read into a DOM

*/

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import java.io.File;
import java.io.IOException;
import org.w3c.dom.*;
import org.xml.sax.ErrorHandler;




public class MyDOMHandler {

static Document document;



   public static void main(String argv[])
   {

		DocumentBuilderFactory factory =
      DocumentBuilderFactory.newInstance();

	  factory.setValidating(true);

      try {


		  DocumentBuilder builder = factory.newDocumentBuilder();
		  builder.setErrorHandler(new MyErrorHandler());
	      System.out.println("\n----------------- Creating the DOM from the CarParts.xml File ---------- \n");
	      document = builder.parse( new File("CarParts.xml") );
	      System.out.println("\n----------------- DOM Created from the CarParts.xml file ---------- \n");


	  } catch (SAXParseException saxException) {
					/* If there are errors in XML data are trapped and location is displayed*/
					System.out.println("\n\nError in CarParts.xml at line:"+saxException.getLineNumber()+"("+saxException.getColumnNumber()+")\n");
					System.out.println(saxException.toString());
				}
		catch (SAXException saxEx) {
							/* If there are errors in XML data, the detailed message of the exception is displayed*/
							System.out.println(saxEx.getMessage());
			}

		catch (ParserConfigurationException pce) {
		      // Parser with specified options can't be built
		      pce.printStackTrace();
			}
		catch (IOException ioe) {
		      // I/O error
      ioe.printStackTrace();
		}




   }// End of main

   static class MyErrorHandler implements ErrorHandler
   	{

           public void fatalError(SAXParseException saxException)
   		{
               System.out.println("Fatal Error occurred "+ saxException);

           }

           public void error(SAXParseException saxException)
   		{
               System.out.println("Error occurred "+ saxException);
           }

           public void warning(SAXParseException saxException)
   		{
               System.out.println("warning occurred "+ saxException);
           }
    }
} // End of MyDOMHandler
