
/*

Modification History
--------------------

Version 1.0
	This example shows how generate SAX Events from a simple text file

*/

import java.io.*;

import org.xml.sax.*;
import org.xml.sax.helpers.AttributesImpl;


public class MySAXEventGenerator implements XMLReader

{

	// Initialize the ContnetHandler to handle the SAX Events
    ContentHandler handler;

    // Variables for namespaces and attribute to be passed to the startElement and endElement methods

    String nsURI = "";  // NamespaceURI
    Attributes atts = new AttributesImpl();




    // Parse the input
    public void parse(InputSource input)
    throws IOException, SAXException

    {
        try {
            // Get an efficient reader for the file

			if (handler==null) {
			  throw new SAXException("No content handler");
            }
            java.io.Reader r = input.getCharacterStream();


            BufferedReader br = new BufferedReader(r);


            String line = br.readLine();


			//Invoke the startDocument method
			 handler.startDocument();


           	  do {
           	  if (line.startsWith("From:"))
              {
					output("From:", line);
			  }
			  else if (line.startsWith("To:"))
			  {
					output("To:", line);
			  }
			  else if (line.startsWith("CC:"))
			  {
			  		output("CC:", line);
			  }
			  else if (line.startsWith("CC:"))
			  {
			  		output("BCC:", line);
			  }
			  else if (line.startsWith("Sent:"))
			  {
			   		output("Sent:", line);
			  }
			  else if (line.startsWith("Subject:"))
			  {
			  		output("Subject:", line);
			  }
			  else if (line.startsWith("MailBody:"))
			  {
			   		output("MailBody:", line);
			  }
            } while (null != (line = br.readLine()));




              handler.endDocument();

        }
     	catch (IOException ioex) {
			System.out.println(ioex.getMessage());
		}
     	catch (SAXException saxEx) {
			/* If there are errors in the data, the detailed message of the exception is displayed*/
			System.out.println(saxEx.getMessage());
        }
    }

    void output(String name, String line)

    throws SAXException

    {

      int textLength = line.length() - name.length();

	  String space = "\n";
      handler.ignorableWhitespace(space.toCharArray(),0,1);
      handler.startElement(nsURI, name, name, atts);
      handler.characters(line.toCharArray(),
                         name.length(),
                         textLength);
      handler.endElement(nsURI, name, name);

    }


    // Enable the application to register a content event handler.
    public void setContentHandler(ContentHandler handler) {
      this.handler = handler;
    }

    // Return the current content handler.
    public ContentHandler getContentHandler() {
      return this.handler;
    }

    // Enable the application to register an error event handler.
    public void setErrorHandler(ErrorHandler handler)
    { }

    // Return the current error handler.
    public ErrorHandler getErrorHandler()
    { return null; }

    // Parse an XML document from a system identifier (URI).
    public void parse(String systemId)
    throws IOException, SAXException
    { }

    //Return the current DTD handler.
    public DTDHandler getDTDHandler()
    { return null; }

    //Return the current entity resolver.
    public EntityResolver getEntityResolver()
    { return null; }

    // Enable the application to register an entity resolver.
    public void setEntityResolver(EntityResolver resolver)
    { }

    // Enable the application to register a DTD event handler.
    public void setDTDHandler(DTDHandler handler)
    { }

    // Get value of a property.
    public Object getProperty(String name)
    { return null; }

    // Set the value of a property.
    public void setProperty(String name, Object value)
    { }

    // Set the state of a feature.
    public void setFeature(String name, boolean value)
    { }

    // Get the value of a feature.
    public boolean getFeature(String name)
    { return false; }
}
