
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.*;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.OutputKeys;

public class MySAXEventGeneratorReader extends DefaultHandler {

static public void main(String[] args) {

        System.out.println("\nVersion 1.0 of MySAXEventGeneratorReader \n");

		try{
		//Get the SAX Parser
		MySAXEventGenerator mySAXEventGenerator = new MySAXEventGenerator();

		/*Attach ContentHandler - the callbacks like startDocument,startElement etc. are o
		 overridden by the setContentHandler to trap them into user code*/
        mySAXEventGenerator.setContentHandler(new MySAXEventGeneratorReader());

		File f = new File("SampleMailMessage.txt");
		FileReader fr = new FileReader(f);
		BufferedReader br = new BufferedReader(fr);
		InputSource inputSource = new InputSource(br);


		/*Parse an XML document - the document is read and overriden callbacks in the MySAXEventGeneratorReader are invoked*/


					TransformerFactory tnsfctry = TransformerFactory.newInstance();

					 Transformer transformer = tnsfctry.newTransformer();



					/*Parse an XML document - the document is read and overriden callbacks in the MySAXEventGeneratorReader are invoked*/
			        //mySAXEventGenerator.parse(inputSource);
			        SAXSource source = new SAXSource(mySAXEventGenerator, inputSource);
			       // String s = document.getDoctype().getSystemId();
								StreamResult result = new StreamResult(System.out);
								//transformer.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, s);
			transformer.transform(source,result);

				}

				catch (IOException ioe) {
				// I/O error
				    ioe.printStackTrace();
					  		}
							catch (TransformerConfigurationException tcex)
							{
								System.out.println(tcex.getMessageAndLocation());
							}
							catch (TransformerException te)
							{
								System.out.println(te.getMessageAndLocation());
		}


    } //End of main

    public void startDocument()
		    {
		        System.out.println("\n Start Document: -----Reading SampleMailMessage with MySAXEventGeneratorReader------\n");
		    }

		    public void startElement(String namespaceURI, String localName,
		                             String qualifiedName, Attributes elementAttributes)
		    {
		        System.out.println("Start Element-> "+qualifiedName);
		    }

			public void characters(char[] ch, int start, int length)
			{
				System.out.println("Characters: " + new String(ch,start,length));
			}

		    public void endElement(String namespaceURI, String localName,
		                             String qualifiedName)
		    {
		        System.out.println("End Element-> "+qualifiedName);
		    }

		    public void endDocument()
		    {
		        System.out.println("\n End Document: ----------------Finished Reading the document---------------------\n");
    }

}