
import java.net.*;
import java.io.*;
import javax.servlet.http.*;
import javax.servlet.*;
import javax.xml.messaging.*;
import javax.xml.soap.*;
import javax.activation.*;
import com.sun.xml.messaging.ebxml.*;


public class MyJAXMClientWithProvider extends HttpServlet {


    private ProviderConnectionFactory pcf;
    private ProviderConnection pc;
    private MessageFactory mf = null;


    public void init(ServletConfig servletConfig) throws ServletException {
        super.init( servletConfig );

        try {
	    pcf = ProviderConnectionFactory.newInstance();
	    pc = pcf.createConnection();
        } catch(Exception e) {

            System.out.println(""+e.getMessage());
        }

    }

    public void doPost(HttpServletRequest req, HttpServletResponse resp)
        throws ServletException

    {
        try {
            // Create a message factory.
	    if (mf == null) {
	        ProviderMetaData metaData = pc.getMetaData();
	        String[] supportedProfiles = metaData.getSupportedProfiles();
	        String profile = null;

	        for(int i=0; i < supportedProfiles.length; i++) {
	  	    if(supportedProfiles[i].equals("ebxml")) {
		        profile = supportedProfiles[i];
		    break;
		    }
	        }
                mf = pc.createMessageFactory(profile);
	    }


            // Create a message from the message factory.
            EbXMLMessageImpl ebxmlMsg = (EbXMLMessageImpl)mf.createMessage();


	    ebxmlMsg.setSender(new Party("http://localhost:8080/chap10"));

	    ebxmlMsg.setReceiver(new Party("http://www.wombats.com/remote/sender"));

		String srvc = req.getParameter("Service");
	    Service service = new Service(srvc);
	    String ref2msgId = req.getParameter("ref2msgid");
	    ebxmlMsg.setRefToMessageId(ref2msgId);
	    String cpaid = req.getParameter("cpaid");
	    ebxmlMsg.setCPAId(cpaid);
	    String conversationId = req.getParameter("conversationId");
	    ebxmlMsg.setConversationId(conversationId);
	    ebxmlMsg.setService(service);
	    String action = req.getParameter("Actn");
	    ebxmlMsg.setAction(action);
	    Manifest manifest = new Manifest("manifest", "1.0");
	    Reference ref = new Reference("pay01", "cid:pay01",
	    			"http://somecompany.org/purchaseordermodel");

	    Schema schema = new Schema(
	    			  "http://somecompany.org/purchaseordermodel.xsd",
				  "1.0");
	    ref.setSchema(schema);

	    Description desc = new Description("en-us");
	    String descptn = req.getParameter("Descptn");
	    desc.setText(descptn);
	    ref.setDescription(desc);
	    manifest.addReference(ref);
	    ebxmlMsg.setManifest(manifest);



        URL url = new URL("http://localhost:8080/chap10/sampledoc.txt");

        AttachmentPart ap =
	    		ebxmlMsg.createAttachmentPart(new DataHandler(url));

            ap.setContentType("text/plain");

            // Add the attachment part to the message.
            ebxmlMsg.addAttachmentPart(ap);

            //Send the message
			pc.send(ebxmlMsg);

			//Log the message
            FileOutputStream sentFile = new FileOutputStream("outputofMyJAXMClientWithProvider.log");
            ebxmlMsg.writeTo(sentFile);
            sentFile.close();

			//Inform the user
            String startHTML =
	    	"<html> <H4> Message delivered to provider. You can see the message that has been sent at <jwsdp_home>/outputofMyJAXMClientWithProvider.log file</H4></html>";
	    OutputStream os = resp.getOutputStream();
	    os.write(startHTML.getBytes());
	    os.flush();
	    os.close();

        } catch(Throwable e) {
	    e.printStackTrace();

        }
    }
}
