
import javax.xml.registry.*;
import javax.xml.registry.infomodel.*;
import java.net.*;
import java.security.*;
import java.util.*;


public class MyDataDeleter {
    Connection connection = null;

    public MyDataDeleter() {}

    public static void main(String[] args) {

                if (args.length < 1) {
            System.out.println("Usage: runclient MyDataDeleter keyString");
            System.exit(1);
        }

        String keyStr = new String(args[0]);
        System.out.println("Key string is " + keyStr);

        MyDataDeleter mdd = new MyDataDeleter();

        mdd.connect();

        mdd.delete(keyStr);

    }


    public void connect() {

        String queryURL =
		            "http://localhost:8080/registry-server/RegistryServerServlet";
		        String publishURL =
		            "http://localhost:8080/registry-server/RegistryServerServlet";

        String httpProxyHost = "";
        String httpProxyPort = "8080";
        String httpsProxyHost = "";
        String httpsProxyPort = "8080";


        Properties props = new Properties();
        props.setProperty("javax.xml.registry.queryManagerURL",
            queryURL);
        props.setProperty("javax.xml.registry.lifeCycleManagerURL",
            publishURL);
        props.setProperty("com.sun.xml.registry.http.proxyHost",
            httpProxyHost);
        props.setProperty("com.sun.xml.registry.http.proxyPort",
            httpProxyPort);
        props.setProperty("com.sun.xml.registry.https.proxyHost",
            httpsProxyHost);
        props.setProperty("com.sun.xml.registry.https.proxyPort",
            httpsProxyPort);

        try {

            ConnectionFactory factory =
                ConnectionFactory.newInstance();
            factory.setProperties(props);
            connection = factory.createConnection();
            System.out.println("Created connection to registry");
        } catch (Exception e) {
		            e.printStackTrace();
		           }

		    }


    public void delete(String keystring) {



        RegistryService rsvrc = null;
        BusinessLifeCycleManager blcmgr = null;

        javax.xml.registry.infomodel.Key key = null;

		        String username = "testuser";
		        String password = "testuser";



        try {
            rsvrc = connection.getRegistryService();
            blcmgr = rsvrc.getBusinessLifeCycleManager();

            System.out.println("Got registry service and business life cycle manager");


            // Get authorization from the registry
            PasswordAuthentication passwdAuth =
                new PasswordAuthentication(username,
                    password.toCharArray());

            Set creds = new HashSet();
            creds.add(passwdAuth);
            connection.setCredentials(creds);
            System.out.println("Security credentials established");

            key = blcmgr.createKey(keystring);
            String id = key.getId();
            System.out.println("Id of the organization to be deleted :" + id);
            Collection keys = new ArrayList();
            keys.add(key);
            BulkResponse response = blcmgr.deleteOrganizations(keys);

            Collection exceptions = response.getExceptions();
            if (exceptions == null) {
                System.out.println("Organization deleted");

                }
            else {
                Iterator excIter = exceptions.iterator();
                Exception exception = null;
                while (excIter.hasNext()) {
                    exception = (Exception) excIter.next();
                    System.err.println("Exception on delete: " +
                    exception.toString());
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally  {
            // At end, close connection to registry
            if (connection != null) {
                try {
                    connection.close();
                } catch (JAXRException je) {}
            }
        }
   }
}
